---
title: WeakMap.prototype.set()
slug: Web/JavaScript/Reference/Global_Objects/WeakMap/set
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Prototype
  - WeakMap
---
<div>{{JSRef}}</div>

<p>The <strong><code>set()</code></strong> method adds a new element with a specified key and value to a <code>WeakMap</code> object.</p>

<div>{{EmbedInteractiveExample("pages/js/weakmap-prototype-set.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>wm</var>.set(<var>key</var>, <var>value</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>key</var></code></dt>
 <dd>Required. Must be <code>object</code>. The key of the element to add to the <code>WeakMap</code> object.</dd>
 <dt><code><var>value</var></code></dt>
 <dd>Required. Any value. The value of the element to add to the <code>WeakMap</code> object.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The <code>WeakMap</code> object.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_the_set_method">Using the set() method</h3>

<pre class="brush: js notranslate">var wm = new WeakMap();
var obj = {};

// Add new elements to the WeakMap
wm.set(obj, 'foo').set(window, 'bar'); // chainable

// Update an element in the WeakMap
wm.set(obj, 'baz');
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-weakmap.prototype.set', 'WeakMap.prototype.set')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.WeakMap.set")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("WeakMap")}}</li>
 <li>{{jsxref("WeakMap.prototype.get()")}}</li>
 <li>{{jsxref("WeakMap.prototype.has()")}}</li>
</ul>
